

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#ifdef WIN32
	#include <winsock.h>
//	#include <ws2tcpip.h>
#else
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <netdb.h>
#endif
#include <errno.h>

//char * inet_addr_buf="127.0.0.1";
char inet_addr_buf[256]="localhost";

int c_lconnect(int port )
{
	struct sockaddr_in serveraddr;
	struct hostent *he;
	int sock;

    if((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
    {
    	printf("connect socket err\n");
    	return -1;
    }

    if ((he = gethostbyname(inet_addr_buf)) == 0)
    {
	printf("Client-gethostbyname() error lol!\n");
    	return -1;
    }

	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port =  htons(port);
//  serveraddr.sin_addr.s_addr = inet_addr(inet_ntoa(*(struct in_addr *)he->h_addr_list[0]));
	serveraddr.sin_addr =  *((struct in_addr *)he->h_addr);
    memset(&(serveraddr.sin_zero), '\0', 8);

    if(connect(sock, (struct sockaddr *)&serveraddr, sizeof(struct sockaddr)) == -1)
    {
    	printf("connect err");
    	return -1;
    }
    else
        printf("Client-The connect() is OK...\n");

	return sock;
}
int c_serv(int port)
{
	struct sockaddr_in server;
    int sock;
#ifdef WIN32
 WSADATA ws;
   if (FAILED (WSAStartup (MAKEWORD( 1, 1 ), &ws) ) ) 
   {
      // Error...
        perror("WSAStartup err\n");
              exit(WSAGetLastError());
   }
#endif
//    if((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
    if((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
    {
        perror("server socket err\n");
#ifdef WIN32
  	printf("LastError=%d\n)",WSAGetLastError());
#endif
        exit(-1);
    }

    server.sin_family = AF_INET;
    server.sin_port = htons(port);
    server.sin_addr.s_addr = INADDR_ANY;
    bzero(&server.sin_zero, 8);

    if((bind(sock, (struct sockaddr *)&server, sizeof(struct sockaddr_in))) == -1)
    {
        perror("bind err");
        exit(-1);
    }

    if((listen(sock, 5)) == -1)
    {
        perror("listen err");
        exit(-1);
    }

    printf("\nThe TCPServer Waiting for client on port %d\n",ntohs(server.sin_port));

    return sock;

}


int c_accept(int sock)
{ int new;
  struct sockaddr_in client;
  int sockaddr_len = sizeof(struct sockaddr_in);

	if((new = accept(sock, (struct sockaddr *)&client, &sockaddr_len)) == -1)
    {
        perror("accept err");
        exit(-1);
    }
	printf("New Client connected from port no %d\n", ntohs(client.sin_port));
//	printf("New Client connected from port no %d and IP %s\n", ntohs(client.sin_port), inet_ntoa(client.sin_addr));

	return new;
}

